-- $Name: ROBOTO$
-- $Version: 0.2$

instead_version "1.8.0"
-- require "dbg"
require "hideinv"
require "quotes"
require "para"
require "dash"
require "metaparser"
set_music 'zl-robot.xm'

input.cursor = img 'cursor.gif'

game.pic = function(s)
	if here() == storage then
		return 'blank:120x440;roboto.png@0,0'
	elseif here() == lab then
		return 'blank:120x440;roboto.png@0,100'
	elseif here() == kitchen then
		return 'blank:120x440;roboto.png@0,200'
	else
		return 'blank:120x440;roboto.png@0,300'
	end
end
morph.debug = true
morph.yo = false
morph:init 'main.lua'

parser.scroll = true
-- parser.filter = true
Attribute [[~smeared]];

iam = obj {
	nam = _'я';
	morph = {'я', 'меня', 'мне', 'себя', 'мной', 'меня' }; -- осмотреть себя, а не меня
	attr [[ hidden, ~dropable, live ]];
	Default = function(s, ev)
		return "Нельзя сделать это со мной."
	end;
	Exam = function(s)
		p [[Всё вроде бы на месте, всё как всегда.]]
		if mirror.general then
			p [[И крышка, к счастью, закрыта!]]
		end
	end;
}

box = obj {
	nam = _'коробка';
	attr [[ openable, opened ]];
	alias [[ Take: Push, Pull ]];
	Exam = "Обычная картонная коробка. Правда, из качественного картона. Внутри лежат разнообразные головоломки и механизмы.";
	Take = "Пусть лучше лежит здесь.";
	Close = [[Зачем закрывать коробку?]];
}

table = obj {
	nam = _'стол';
	Exam = [[Стол из тёмного металла, который поддерживает разнообразные устройства.]];
	Take = [[Стол намертво вделан в пол лаборатории.]];
	alias [[ Take: Pull, Push ]];
	Search = redirect ('devices', 'Exam');
	obj = { 'devices' };
}

vaseline = obj {
	attr [[ openable, takeable,~general ]];
	alias [[ Drop: Putin, Puton, Putunder ]];
	nam = _'вазелин|~баночка вазелина';
	Default = function(s, ev, o)
		if ev ~= 'Smear' and o ~= s and o then
			p [[Вазелином это сделать нельзя.]];
		end
	end;
	Exam = function(s)
		p [[На плоской баночке с откручивающейся крышечкой написано "Vaseline". Сейчас баночка ]];
		if s.opened then
			pr "открыта";
		else
			pr "закрыта";
		end
		if s.general then
			pr ". К тому же, она уже была использована"
		end
		p "."
	end;
	Smell = function(s)
		if s.opened then
			p "Твои рецепторы улавливают... видимо, запах вазелина."
		else
			p "Баночка закрыта, и наверное поэтому твои рецепторы не улавливают никаких запахов."
		end
	end;
	musthave [[Open, Close ]];
	after_Open = "Ты откручиваешь крышку с баночки вазелина.";
	after_Close = "Ты закручиваешь крышку обратно на баночку.";
	Eat = "Пусть это вроде бы и пищевая добавка, но роботам всё равно не нужно есть, в отличие от <i>них</i>.";
	Drop = "Нет, лучше оставить вазелин с собой, мало ли он ещё пригодится.";
}:disable()
papers = obj {
	nam = _'бумаги';
	Exam = "Разные бумажки с диаграммами, чертежами, схемами.";
	Default = "Пусть лучше лежат.";
}:disable()

windows = obj {
	nam = _'окна';
	before_Default = [[Это не шутка, здесь их правда нет.]];
}

counter = obj {
	nam = _'прилавок';
	Exam = function(s)
		p "На прилавке, который идёт вдоль южной стены, в основном лежат стопки бумаг со всякими надписями и чертежами.";
		if not have 'vaseline' then
			p " Среди всего этого хлама также лежит баночка вазелина. Интересно, кто её тут оставил."
			vaseline:enable()
			papers:enable()
		end
	end;
	obj =  { 'vaseline', 'papers' };
}

devices = obj {
	nam = _'устройства';
	Exam = function(s)
		p "На столе установлено множество различных непонятных устройств, агрегатов и аппаратусов. Например, здесь есть "
		local r = rnd(3)
		if r == 1 then
			p "что-то похожее на перегонщик мочи в воду."
		elseif r == 2 then
			p "круглая штуковина с кучей магнитов."
		else
			p "очень хитрая система из блоков, рычагов и шестерёнок."
		end
	end;
	Take = "Лучше их не трогать, а то еще сломаешь.";
	alias [[ Take: Pull, Push ]];
}

puzzles = obj {
	nam = _'головоломки|механизмы';
	Exam = [[Здесь лежит набор разных головоломок и механизмов, с которыми ты любишь играть, 
		когда находится свободное время. Правда они уже порядком тебе поднаскучили -- например, 
		кубик Рубика 5x5x5 ты можешь собрать за минуту.]];
	Take = "Сейчас у тебя есть дело по-важнее.";
	alias [[ Take: Search, Remove ]];
}

mirror = obj {
	attr [[ ~general ]];
	alias [[ Take: Pull, Push ]];
	nam = _'зеркало';
	Exam = function(s)
		p [[Прямоугольное высокое зеркало в гладкой металлической оправе, которое 
			установлено на крепкой подставке. В нижнем левом углу поверхности 
			чёрным маркером написано "Лаб 38-K"]]
		if not s.general then
			p " Интересно, как хорошо оно отражает?"
		end
	end;
	Take = "Оно слишком тяжёлое, да и указаний куда-то его тащить не было";
	Lookat = function(s)
		if s.general then
			p "Второй раз тебе в него смотреть не хочется.";
		else
			s.general = true
			p [[Ты подбираешься ближе к зеркалу, чтобы посмотреть в отражение, и 
			с ужасом видишь, что ты совсем не такой, каким себя представлял. 
			Ты -- робот. Настоящий такой, низкий, цилиндрической формы робот. 
			Неудивительно, что кто-то из лаборантов в шутку называл тебя "Эр два дэ два"... 
			Правда, у тебя довольно функциональные "руки", и это уже хорошо.^^
			Что ещё хуже -- ты голый! Ну, настолько, насколько робот может быть голым. 
			Ты закрываешь переднюю крышку, чтобы никто ненароком не увидел 
			твои нежные электронные внутренности.]]
		end
	end;
	Attack = function(s)
		if s.general then
			p "Ты бы с удовольствием разбил это зеркало, чтобы больше его никогда не видеть, но ничего хорошего из этого не выйдет.";
		else
			p "Пожалуй, не стоит -- ничего хорошего из этого не выйдет."
		end
	end;
}

main = room {
	nam = 'Пролог';
	enter = function(s)
		p "^Текстовая игра за один день. Вжж!^yandexx, (С) 2010.^";
		p "Адаптация для INSTEAD выполнена Петром Косых в 2012.^^"

		p [[ <b>beep</b> <b>beep</b>^^
		"19:00. Состояние гибернации окончено"^^
		Что? Кто здесь?^^
		"Дроид номер 13, приступайте к выполнению задания", -- говорит синтезированный женский голос.^^
		Ах, да. Как обычно. Но почему-то тебе никак не привыкнуть.]];
		walk 'storage'
	end;
}

storage = room {
	nam = "Кладовка";
	dsc = [[Твоё обычное место обитания, можно сказать -- дом. Довольно тёмное место, что, впрочем, 
	не мешает тебе здесь свободно ориентироваться -- всё знакомо, и ничего не меняется.^^
	В углу находится место, где ты обычно спишь (гибернируешь), рядом в коробке лежат головоломки и механизмы. 
	Однако здесь также появился новый объект, вчера его не было -- высокое прямоугольное зеркало на металлической подставке. 
	Должно быть, кто-то поставил его сюда, пока ты спал (гибернировал).]];
	footer = [[Единственный выход ведёт на юг в лабораторию.]];
	exit = function(s)
		if not mirror.general then
			p "Перед тем как начать работу в комплексе, тебе бы хотелось узнать, что же это за зеркало."
			return false
		end
	end;
	s_to = 'lab';
	obj = { 'box', 'puzzles', 'mirror' };
}

lab = room {
	nam = 'Лаборатория';
	entered = function(s)
		if not visited(s) then
			p "Настало время поработать. Нужно убрать за всеми мусор.";
		end
	end;
	dsc = [[Здесь <i>они</i> обычно проводят всякие эксперименты. В центре комнаты на столе 
		стоят разнообразные сложные агрегаты, а вдоль южной стены тянется прилавок, 
		на котором валяется всякий околонаучный хлам. Окон совсем нет.]];
	footer = [[Отсюда можно пойти на восток на кухню или вернуться в кладовку на север.]];
	n_to = 'storage';
	e_to = 'kitchen';
	obj = { 'table', 'counter', 'windows' };
}

table_trash = obj {
	nam = _'зефир';
	attr [[ takeable, eatable ]];
	musthave [[ before_Eat ]];
	Exam = "Это половинка одной зефиринки в шоколаде, с отчётливо видным отпечатком зубов.";
	Eat = "Ты не питаешься так, как это делают <i>они</i>.";
	Drop = "Ты не можешь мусорить.";
}:disable();

window = obj {
	nam = _'окно';
	attr [[ ~general ]];
	before_Exam = code [[self.general = true; horse_window:enable() ]];
	Exam = "Оказывается, за окном пасётся очень милая лошадка. Само окно обычное. Хотя возможно, оно пуленепробиваемое.";
	alias [[Exam: Search, Lookat ]];
	obj = { 'horse_window' };
}

sun = obj {
	nam = _"солнце";
	Exam = "Солнце освещает всё вокруг яркими лучами.";
	alias [[Exam: Lookat ]];
	Default = "Солнце слишком далеко (примерно в 150 миллионах километров от тебя).";
}

horse_window = obj {
	nam = _"лошадь";
	Exam =  "Милейшее создание. Ты бы с удовольствием сел на неё верхом и умчался бы далеко-далеко.";
	Default = "Она стоит с той стороны, за окном.";
}:disable()

sink = obj { 
	nam = _"раковина";
	Exam = "Обычная металлическая раковина незамысловатого дизайна.";
}

oven = obj {
	nam = _"плита";
	Exam = "Обычная плита. Иногда в ней что-нибудь готовят. К счастью, тебе не приходится этим заниматься.";
	before_Smell = "Пахнет курицей.";
	before_Open = "Сейчас не обеденное время.";
}

shelves = obj {
	nam = _"полочки";
	before_Default = "На полочках совсем ничего нет."
}

table2 = obj {
	nam = _"стол";
	Exam = function(s)
		p "Посередине стоит прозрачный низкий стол с современным дизайном. Наверняка, он был сделан в Швеции.";
		if exist(table_trash, s) then
			p " На столе лежит недоеденный кем-то зефир.";
			table_trash:enable()
		end
	end;
	obj = {'table_trash' };
}

chairs = obj {
	nam = _"стулья",
	Exam = "Около стола стоят два простых деревянных стула со спинками.";
}

garnitour = obj {
	nam = _'~кухонный гарнитур|гарнитур',
	before_Exam = code [[ section:enable() ]];
	Exam = "Он очень простой: раковина, плита, отделение внизу с дверцей и полочки наверху.";
}

section = obj {
	attr [[openable,~general]];
	nam = _"дверца";
	Exam = function(s)
		p "Отделение с металлической дверцей, в котором находится мусорное ведро. Сейчас дверца";
		if not s.opened then
			p "закрыта."
		else
			p "открыта."
		end
	end;
	Attack = [[Дверца металлическая.]];
	before_Open = function(s, w)
		if not petlya.smeared then
			if not s.general then
				s.general = true
				p "Ты пытаешься открыть металлическую дверцу, но её почему-то заело.";
			else
				petlya:enable()
				p "Ты вновь пытаешься открыть дверцу, за которой должно быть мусорное ведро, но у тебя не получается. Наверное, что-то с петлями.";
			end
		else
			s.opened = true
			p "Ты с лёгкостью открываешь смазанную дверцу, и твоему взгляду предстаёт мусорное ведро.";
			urn:enable()
		end
	end;
	obj = { 'urn' };
}:disable()

urn = obj {
	nam = _'ведро';
	attr [[ ~general ]];
	Exam = "В это мусорное ведро положено складывать весь мусор.";
	before_Search = "Нечего копаться в никому не нужном мусоре.";
	before_Receive = function(s, w)
		if w == table_trash then
			s.general = true
			inv():del(w)
			p [[Ты выбросил зефир в вердро.]]
		end
	end;
}:disable();

petlya = obj {
	nam = _'петли';
	attr [[~smeared]];
	Exam = function(s)
		p "Дверные петли, похоже, немного поржавели.";
		if s.smeared then
			p "Но зато теперь они смазаны вазелином.";
		end
	end;
	before_Attack = "Это может всё только усугубить, и ты никогда больше не откроешь эту дверцу.";
}:disable()

kitchen = room {
	nam = "Кухня";
	dsc = function()
		p [[Официально это место называется "комната для приёма пищи". 
			Посередине стоит низкий обеденный стол с парой стульев возле него, 
			а в восточной стене находится небольшой кухонный гарнитур и окно с видом наружу.^^
			В северной части восточной стены также есть окно. На улице ярко светит солнце,]]
		if not window.general then
			p " а с той стороны за окном есть что-то, что привлекает твоё внимание.";
		else
			p " и в его лучах снаружи пасётся лошадка.";
		end
	end;
	Smell = [[Здесь пахнет человеческой едой.]];
	footer = "Главный выход ведёт на север, а лаборатория находится на западе.";
	w_to = 'lab';
	n_to = 'TheEnd';
	obj = { 'window', 'table2', 'chairs', 'garnitour', 'section', 'petlya', 'sink', 'oven', 'shelves',  'sun'};
}

parser.events.after_Smear = function(self, s, w)
	if s == roboto then
		p [[Не надо себя ни на что намазывать.]]
		return
	end
	if s ~= vaseline then
		p [[Это нельзя ни на что намазать.]]
		return
	end
	if not have 'vaseline' then
		p [[У тебя нет баночки.]]
		return
	end
	if w == s then
		p "Тебе и так сложно её держать своими конечностями, а если помазать баночку, то это будет просто нереально.";
		return
	end
	if w == roboto then
		p "Ты надеешься, что <i>тебе</i> вазелин не понадобится.";
		return 
	end
	if not s.opened then
		p "Баночка вазелина закрыта.";
		return
	end
	if w.smeared then
		local rc = self:gender(w)
		if rc.plural then
			rc = 'ы';
		elseif rc.male then
			rc = '';
		else
			rc = 'а';
		end
		p (self:cap(w:M 'им')..[[ уже смазан]]..rc..[[ вазелином, так что наверное больше не нужно.]])
		return
	end
	p ("Ты берёшь немножко вазелина из баночки и намазываешь его на "..w:M('вн')..'.')
	w.smeared = true
	s.general = true
	return
end

TheEnd = room {
	nam = 'КОНЕЦ';
	hideinv = true;
	forcedsc = true;
	enter = function(s)
		if not urn.general then
			p "Ты ещё не убрал мусор, который <i>они</i> оставили.";
			return false
		end
--		set_music 'end.it'
	end;
	dsc = [[Ты выходишь на улицу. Здесь так светло и хорошо, и тебе совсем не хочется возвращаться назад. 
	А неподалёку стоит лошадка, запряжённая в небольшую тележку, и жуёт травку. 
	Ты заезжаешь в тележку (ах как было бы хорошо поехать на лошади верхом, но увы), 
	и вы вдвоём уезжаете далеко-далеко.^^
	И ты надеешься, что вазелин тебе больше никогда не понадобится.]];
}

parser.events.Help = [[
	Эта игра была написана за один день, специально для конкурса Вжж.^^
	Спасибо Евгу за организацию конкурса и Серому Волку за отважное бета-тестирование.^^
	Также выражаю респекты Грэму Нельсону и Денису Гаеву за лучшую в мире IF-платформу.^^
	И дополнительно посылаю ментальные факинги всем упёртым менюшникам!^
	<i><r>yandexx</r></i>^^
	От лица упёртого менюшника выражаю огромную благодарность Yandexx'у за разрешение перенести игру на INSTEAD
	для демонстрации мета-парсера.^
	<i><r>Пётр Косых</r></i>
]]

Verb { "Help", "~помощь" }
-- Verb { "Help", "~об игре" }
Verb { "Smear %3 %2|Smeared %2 %3", "~смазать", "{obj}вн", "{inv}тв" }
Verb { "Smear %3 %2|Smeared %2 %3", "мазать", "{obj}вн", "{inv}тв" }
Verb { "Smear %2 %4|Smeared %4 %2", "~намазать", "{inv}вн", "на", "{obj}вн|{inv}вн" }
